package com.zm.order.tool.server.config;

import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.ProducerConfig;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * kafka生产者配置
 *
 * <p>
 *
 * </p>
 *
 * @author nianchang
 * @date 2023/08/14 4:28 下午
 */
@Component
public class KafkaProduceConfig {

    @Value("${kafka.produce.servers}")
    private String servers;

    @Value("${spring.kafka.producer.ack}")
    private String ack;

    @Value("${spring.kafka.producer.buffer-memory}")
    private Long bufferMemory;

    @Value("${spring.kafka.producer.batch-size}")
    private Integer batchSize;

    @Value("${spring.kafka.producer.retries}")
    private Integer retries;

    @Value("${spring.kafka.producer.properties.max.request.size}")
    private Integer maxRequestSize;

    @Value("${spring.kafka.producer.properties.request.timeout.ms}")
    private Integer requestTimeoutMs;

    public Map<String, Object> producerConfigs() {
        // 创建Kafka的配置信息
        Map<String, Object> properties = new HashMap<>(16);
        // 指定broker，会自动从broker中获取元数据信息
        properties.put(ProducerConfig.BOOTSTRAP_SERVERS_CONFIG, servers);
        // 执行ack应答机制
        properties.put(ProducerConfig.ACKS_CONFIG, ack);
        // 指定重试次数
        properties.put(ProducerConfig.RETRIES_CONFIG, retries);
        // 指定批处理的字节数
        properties.put(ProducerConfig.BATCH_SIZE_CONFIG, batchSize);
        // RecordAccumulator缓冲区大小
        properties.put(ProducerConfig.BUFFER_MEMORY_CONFIG, bufferMemory);
        // 指定key序列化器
        properties.put(ProducerConfig.KEY_SERIALIZER_CLASS_CONFIG, "org.apache.kafka.common.serialization.StringSerializer");
        // 指定value序列化器
        properties.put(ProducerConfig.VALUE_SERIALIZER_CLASS_CONFIG, "org.apache.kafka.common.serialization.StringSerializer");
        // 生产端能够发送的最大消息大小，默认值为1048576字节(1M)
        properties.put(ProducerConfig.MAX_REQUEST_SIZE_CONFIG, maxRequestSize);
        // 控制客户端等待请求响应的最长时间。
        // 如果超时之前仍未收到响应，则客户端将在必要时重新发送请求，如果重试次数（retries）已用尽，则请求失败。
        // 此值应大于replica.lag.time.max.ms（broker配置），以减少由于不必要的生产者重试而导致消息重复的可能性。
        properties.put(ProducerConfig.REQUEST_TIMEOUT_MS_CONFIG, requestTimeoutMs);
        return properties;
    }

    @Bean
    public KafkaProducer<String, Object> createKafkaProducer() {
        return new KafkaProducer<>(producerConfigs());
    }
}
